# EllipseFit History

3.9.0.14 (2022-05-19)
* Added GitHub url link in Help menu.
* Added macOS M1 version.
* Numerous updates to User Manual.
* Added PDF export.
* Fixes to SVG export.
* Fixes to EPS export.
* Fixes to Find command.
* Fixes to save ellipsoid bootstrap.
* Numerous upgrades to ellipsoid error analysis.
* Added 'Section data' option to Monte Carlo ellipsoid calculation option.
* Added 'Bootstrap' using section data to bootstrap ellipsoid solution.
* Added 'Bootstrap' using bootstrap section ellipses to bootstrap ellipsoid solution.
* Improvements to Automated Wellman method.
* Improvements to Line Stretch analysis.
* Added example belemnite data for line stretch analysis.
* Numerous fixes and refactoring.

3.8.2.1 (2021-11-20)
* Fixed bug in Shade Plot.
* User Manual is now a separate download.
* Added Help menu command to open User Manual.

3.8.1.14 (2021-09-05)
* Fixed auto-scaling of Nadai-Hsu plot.
* Fixed auto-scaling of Flinn-Ramsay plot.
* Fixed Cancel and OK button enabling in 'Calculate Ellipsoid' dialog.
* Fixed Prewitt option in Edge Fabric Ellipse, it was always using Sobel.
* Fixed saving of ellipsoid calculation results to Orient file.
* Fixed showing selected only ('Plot Selected Only') in image window.
* Added Paste command for the data spreadsheet window.

3.8.0.8 (2020-07-20)
* Phi Calc, R Calc renamed Phi Est, R Est
* dH is now reported in degrees instead of radians.
* The ellipsoid calculation now runs non-modally, displays progress, and can be canceled.
* Fixed bug in hyperbolic distance calculation.
* Added confidence ellipses to Flinn-Ramsay, Nadai-Hsu, Rf/phi, Elliott polar and hyperbolic plots.
* Added edge fabric ellipse (Glazner and Walker, 2000).
* Numerous fixes and updates.
* Complete revision of user manual.

3.7.4.8 (2020-01-05) 
* Fixes to exception handling for preference file opening.
* Starting with Shift key pressed now deletes preferences.
* Early Fortran version dating to 1983 discovered, updated copyright.
* Modified display colors in spreadsheet.
* Fixed some control sizes.
* Fixed error causing shade plot not to update.
* Additional bug fixes.

3.7.3.11 (2019-11-19)
* Added latitude, longitude to UTM conversion.

3.7.2.10 (2019-09-16)
* Fixes to some Macintosh control issues, including a scrolling bug.
* Fixes to some localization issues for files using comma decimal makers.
* Added strain from velocities calculations.

3.7.0.33 (2019-08-16)
* Added Displacement Stretch Plot, with least squares and strain probe numerical solutions.
* Added Displacement Map capabilities to Strain Map. 
* Now reads data with Station and Time ID fields for displacement plots and calculations.
* Fixed bug in spreadsheet number field export, numbers were exporting as text.
* Numerous fixes to support Windows multiple DPI modes.
* New toolbar icons at multiple resolutions for multiple DPI modes.
* Fixes to opacity and gradient pickers, and symbols menus.
* Numerous additional fixes, for screen display and other issues.
* Implemented High DPI scaling code for Windows 150% and 200% modes, including new icon sets.
* Fixes to allow localization by country of decimal separators other than decimal point. Files use decimal point separators. 

3.6.3.0 (2018-11-17)
* Preference files updated to JSON from XML. Files are updated when accessed.

3.6.2.8 (2018-11-09)
* Fixed access error following Calculate Ellipsoid dialog closing in MacOS. 
* Moved Synthesize Data command from File to Data menu.
* Limited Synthesize Data command to R <= 100 to avoid program hangs while plotting data.
* Fixed Copy and Cut commands in Data window.
* Added Undo for Cut command in Data window.
* Ellipsoid axes confidence intervals converted from radians to degrees.
* Added apical angle 95% confidence interval for ellipsoid axes. 

3.6.1.2 (2018-10-26)
* Data Columns dialog now sets column visibility as: visible, hidden, or visible if available.
* Updated EllipseFit and User Manual to correctly name ellipsoid error calculations.

3.6.0.9 (2018-09-02)
* Added draggable rotation of ellipsoid shade plot.
* Added display of ellipsoid sections.
* Code refactoring and fixes for open source release and Cocoa 64 bit fixes.
* First Cocoa beta release. 
* Adding warning when deleting data rows.
* Fixes to PaintPicker opacity selection and menus. 
* Fix to list selection in shade plot when preferences are updated and list is not current.
* Fixed bounding box algorithm for shade plots. 
* Fixed bug in the rectify option during the transform data operation.
* Fixed bug in saving relative file paths of open files. If an error occurs when quitting the application with open files, restart EllipseFit and close and reopen all files.

3.5.2.6 (2018-07-21)
* Added data columns for ellipsoid Flinn-Ramsay and Nadia-Hsu plots: Max/Min, Int/Min, Max/Int, K, Epsilon, and Nu.
* Changed labels on Nadia-Hsu plot to 'ν', 'ϵ'.
* Changed name of Flinn plot to Flinn-Ramsay plot.
* Fixed error in status bar display of k and K on Flinn-Ramsay plot.
* Fixed plot axis label format for labeled increments of less than 1.
* Renamed Polygon digitizing command to Shape.
* Added Data Columns command and dialog to show or hide columns.

3.5.1.3 (2018-06-13)
* Code refactoring and fixes. 
* Updated math libraries to remove closed source dependencies of eigenvalue, LU decomposition, matrix inversion, linear solutions, and several other routines.
* Recompiled with FPC 3.0.4, LCL 1.8.3.0.
* Added Ellipsoid plots (Section 10.1.3).

3.5.0.19 (2018 May 13)
* Fixed bug in contour gradient drawing.
* Fixed data window panel width.
* Changed the error message in the 'Error Opening File' dialog to indicate that the file may be open in another application.
* Renamed Filled Polygon digitizing command to Filled Shape.
* Renamed Ellipse digitizing command to 5-Point Ellipse.
* Fixed Bucket Fill for units other than pixels.
* Added Quadrilateral digitizing command, see Section 2.2.5.
* Added Ellipse Axes digitizing command, see Section 2.2.3.
* Added popup menu for image digitizing modes.
* Fixed possible math error when ellipsoid bootstrap resamples = 0, and updated ellipsoid dialog getters and setters.
* Fixed spreadsheet File Open bug.
* Fixed font setting in Log window, was not remembering changes.
* Fixed font sizes in Windows XP and Linux.
* Fixed axis drawing bug in polar plots.
* Fixed clipping of gradient in SVG polar plots.
* Now switches data sheets when plot window for that data is selected.
* Now includes name of polar plot in statistics log.
* Log file now opens automatically after a calculation.
* Recompiled with FPC 3.0.4, LCL 1.8.2.0.
* Numerous internal changes to dialog boxes, all TStaticText replaced with TLabel.
* Extensive additions to the User Manual. 
* Added Robin’s (2002) method for ellipsoid calculation.
* Implemented column sorting.
* Fixed bugs in drawing Flinn and Nadai-Hsu plot grid lines.
* Added bootstrap of ellipsoid calculation from section bootstrap files.
* Added Close Window command.

3.4.0.14 (2017-07-08)
* Consolidated plot image saving to Export Image As command.
* Added eps and dxf image export. Note these formats do not support all options, better results may be obtained by exporting as svg. 
* Fixes to Synthesize Data dialog.
* Added Modified flag to data window.
* Fixed Transform Data dialog to allow shear strain, translations, and rotations.
* Added Windows menu list of plot windows.
* Fixed bug in gnomic plot, was not setting R max.
* Added options to make it easier to scale digitizing in units other than pixels, see Section 2.2.1.
* Added Export CSD command to output crystal size distribution data, see Section 2.1.3.
* Added Save command in addition to Save As.
* Fixed Save As command to rename graph and data windows.
* Added optional tick marks to polar and Rf/phi plots.
* Extensive rewriting of the user manual.
* Added Fry, polar, and Rf/phi toolbar icons.
* Replaced Wellman and Stretch centered least-squares ellipse fitting with more robust constrained least squares fitting.

3.3.0.62 (2017-03-14)
* Added Apply/Undo to Edge Detection dialog.
* Added Apply/Undo to Image Filters dialog.
* Added Median, Convert BW, and Invert BW image filters.
* Changed line pair fields to X11, Y11, X12, Y12, X21, Y21, X22, Y22, for line and point.
* Added Alpha1 and Alpha2 fields for directed angle of lines, and Beta for the angle between the lines.
* Fixed display of filled particle when deleted from spreadsheet.
* Added optional display of ellipse axes.
* Added Area field to ellipse spreadsheet. 
* Fixed bug in Image Filters histogram.
* Added Windows Taskbar icons.
* Changed messaging procedures from PostMessage to Dispatch to fix display bugs (the data window was not reliably updating display of the data after opening a data file). 
* Added Fit Void command and dialog box for void fitting routines. 
* Added exponential edge detection, density gradient, weighted least-squares void fitting methods with variants.
* Added bootstrapping to exponential edge detection, and enhanced normalized fitting methods. 
* Fixed control heights in dialog boxes.
* Added Edit metadata command to edit file metadata, initial lines in file beginning with “//”.
* Image Transform command dialog rewritten with fixes.
* Data Transform command dialog rewritten with fixes.
* Image Filters command dialog rewritten with fixes.
* Reorganized menu structure.
* Implemented transform data undo stack using data copies instead of inverse transforms.
* Now reopens last open files if possible. 

3.2.2 (2015-10-26)
* Fixed listbox display in Preferences dialog.
* Fixed bug with non-roman unicode characters in drive name. Workaround is to run from thumb drive.
* Maintenance upgrade compiled with Lazarus 1.4.4. 
* Improved redraw speed of images when digitizing. Further optimization may be possible in subsequent versions. Thanks to Gabriele Casale, Appalachian State University, for reporting the issue.
* Fixed display of symbols on Ratio Plot. Changed labels from A, B, C to Max, Int, and Min.

3.2.1 (2015-08-05)
* Cleaned up main preferences dialog control placements, and tooltips.
* Fixed bug causing jump of preferences dialog on preview.
* Optimized data grid display scrolling.
* Changed “N” column header to “ID”. ID is a unique integer assigned to identify a single particle. Files will read in correctly with either “N” or “ID”, but will be written with “ID”.
* Modified desktop icon.
* Replaced term “graph” with “plot” in menu and manual.
* Work on user manual.
* Implemented opening of multiple data files with associated data plots. File > New and File Close commands added. 
* Default view is now the Data Window instead of Image Window. 
* Open Data and Open Image shortcuts swapped. 
* The last Open Data and Open Image paths ares now saved.
* Fixes to Nadai and Flinn plots.
* Optimized messaging.
* Added warning dialog to Reset Preferences.

3.2.0 (2015-01-28)
* Prevented redrawing of data on image when adding or undoing digitized points to speed up redraw with numerous data points or slow processors. 
* Replaced StringGrid with DrawGrid and with numerous related internal modifications in viewing and updating the data grid.
• Enabled status bar in Data Window.
* Changed SendMessages to PostMessages.
* Fixed enabling of Ratio Graph.
* Added multiple selections in Data Window. Use Command/Control click for adding or removing items, and Shift click to extend selection.
* Added multiple selections in Image Window. Use Command/Control click for adding or removing items.
* Added multiple selections to Rato, Flinn, Nadia, Polar, Rf / phi, Wellman and Stretch Graphs. Use Command/Control click for adding or removing items. 
* Added multiple selections on Strain Map. Use Command/Control click for adding or removing items. 
* Fixed Rf / phi Save As and Export commands.
* Added Select All, Select None, Select Inverse commands.
* Known bug: Audio alerts do not work in Linux.
* Known bug: Menu commands do not initially update in the Data Window. Work around is to click on Image Window and back to the Data Window.
* Trying to use File > Open Image (instead of File > Open Data) to open a data file now gives a warning dialog with the option to open it as a data file.
* Numerous changes to Analyse > Synthesize Data command. Particle ratios are randomly selected from a range RMin...RMax on Ln(R), or from a Gaussian distribution on Ln(R) with a mean of Ln(RMean) and standard deviation of Sigma. Area can also be selected from a Gaussian distribution with a mean area of pi. Orientations are selected randomly from either a range in phi or from a Von Mises distribution. 
* Fixed settings dependancies in Fry Panel of Preferences Dialog.
* Added Delaunay triangulation and Voronoi graphs to Strain Map options. 
* Added Delaunay nearest neighbor option to Fry Graph.

3.1.1 (2014-11-06)
* Added the ability to open Microsoft® Excel® XLS (legacy) and XLSX formats, in addition to OpenDocument ODS spreadsheet, and delimited file (CSV, TSV) formats. In each case, a comment line starts with '//', and a header row identifying the data columns must precede the data rows.
* Fixed bug requiring “Max”, “Min” data and header as well as “R” for ellipsoid calculation. Also now allows “Pitch” header in place of “Phi”. Thanks to Kurt Burmeister for reporting this.
* Replaced timers with event messaging.
* Fixes to Analyze > Data Synthesis command, which failed in Windows. The collision tests counts have been increased to 10,000 x 10,000, which tightens adjacent particle contacts. 

3.1.0 (2014-06-04)
* Added bootstrap error analysis to ellipsoid calculations. This has some similarities to the kernel density estimation approach of Mookerjee and Nickleach (2011).
* Added saving of the ellipsoid axes orientations for plotting on spherical projections in Orient.
* Changed column headers A, B, C to Max, Int, Min to clarify the axial lengths. EllipseFit will open files with the old headers, but will save them using the new headers.
* Removed option to save files as “Space Delimited”. This format potentially causes issues parsing files with spaces in the header column. EllipseFit will still open space delimited files with recognizable headers.
* Added 95% confidence regions to Nadai graph.
* Added 95% confidence regions to Flinn graph.
* Added option to save bootstrap ellipsoid axes.
* Added numerous options to Synthesize Data command. These include generating the strain ratio from a Gaussian normal distribution, generating particle size from a Gaussian normal distribution, generating a preferred orientation from a Von Mises circular distribution, generating centers at a truncated Poisson distribution. The latter is performed by randomizing the location in x, y and discarding collisions.
* Added an option to the Strain Map command to either plot scaled strain ellipses or particle axes.
* Implemented the maximum mean log likelihood function (MLLF) search procedure of Shan and Xiao (2011). This gives a high accuracy strain estimate from Fry-type data, that is, data from truncated Poisson distributions. It does not require ellipse data, and it is not subjective and is reproducible. 
* Fixed auto-scaling on Fry graphs.
* Significant progress on the User Manual.

3.0.3 (2014-05-13)
* Added transforms to image to rotate, flip, strain, unstrain, etc. To strain or unstrain both image and data, transform the image first. This calculates the origin offset in the new bitmap. Then transform the data at (X0, Y0) = (0.0, 0.0) with “Rectify” checked.
* Added transform data to Wellman-type data.
* Changed default bootstrap resamples from 300 to 5000.
* Rewrote ellipse standard error and confidence interval methods. Changed from using resample trials to calculate standard error and Student T for confidence interval, to use resampled data for both. Non-bootstrap MRL uses analytical error and Student T following Mulchrone (2005).
* Added option to save bootstrap resample ellipses.
* Added option to plot 95% confidence regions on polar and Rf / phi graphs using analytical error.
* Fixed bug that was swapping A and B radii while digitizing polygons.

3.0.2 (2014-04-21)
* Fixed bug in fill ellipse routine causing hangs at high thresholds.
* Fixed bug causing crash when opening page size dialog.
* Added strain map.
* Added synthesize data to create data sets.
* Added transform data to strain, unstrain, shear, etc., data.
* Changed names of digitize routines to reflect the objects, e.g., center points, ellipses, polygons, instead of the results (e.g., polygon moment ellipse).
* Changed names of graphs to more common specific names attributing authors, Fry, Flinn, etc., instead of generic names.
* Internal change in form communication, from flags and timers to messages.
* Numerous additional fixes and changes.

3.0.1 (2014-04-06) 
* Fixed bug effecting symbol colors in svg graphics.
* Cleaned up the polar graph.
* Fixed cursor status strings on graphs.
* Fixed up contouring preferences.
* Added axial ratio Flinn type graph. 
* Added octahedral Nadai-Hsu type strain graph. 
* Added ellipse digitizing with polygon fill and moments.
* Fixed file save warning.
* Numerous internal changes.

3.0.0 (2014-03-24)
* First public release of Version 3.

3.0.0.28 (2012-08-01)
* Initial prerelease of Version 3.

2.0.1 (2012-09-06)
* Fixed center to center plot crash when Enhanced option was selected and no radii (A, B) data are available.
* Added context help to indicate that the Enhanced option has no effect without radii data. 
* Fixed menu item for Digitize Lines which was not selecting that option.

2.0.0 (2010-10-07)

1.0.7 (1999-01-02)


